package gus05.entity.gus.file.action.exploredir;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.framework.resources.ActionBuilder;



public class ExploreDir implements Entity, Give, Transform {


    public String getName()				{return "gus.file.action.exploredir";}
    public String getCreationDate()		{return "2007.04.08";}

    public static final String ACTION_ID = "FILEACTION_exploreDir";

    private ActionBuilder builder;
    
    public ExploreDir() throws Exception
    {builder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");}



    public void give(Object obj) throws Exception
    {
        File dir = (File)obj;
        if(!dir.isDirectory()) throw new Exception("path "+dir.getAbsolutePath()+" is not a directory");
        exploreDir(dir);
    }



    public Object transform(Object obj) throws Exception
    {
        File dir = (File)obj;
        if(!dir.isDirectory()) throw new Exception("path "+dir.getAbsolutePath()+" is not a directory");
        return builder.build(ACTION_ID,new ExecuteExplorer(dir));
    }


    private class ExecuteExplorer implements Execute
    {
        private File dir;
        public ExecuteExplorer(File dir){this.dir = dir;}
        public void execute() throws Exception {exploreDir(dir);}
    }



    
    private void exploreDir(File dir) throws Exception
    {Runtime.getRuntime().exec(command(dir));}
    
    
    
    
    
    private String command(File dir) throws Exception
    {
        String path = dir.getAbsolutePath();
        if(isWindows()) return "explorer \""+path+"\"";
        if(isMac()) return "open -a finder "+path;
        throw new Exception("Unknown explore command for OS "+os());
    }
    
    private boolean isWindows()
    {return os().toLowerCase().contains("windows");}
    
    private boolean isMac()
    {return os().toLowerCase().contains("mac");}
    
    private String os()
    {return System.getProperty("os.name");}
}

