/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.file.explorer.tree2;


import javax.swing.event.*;
import javax.swing.tree.*;

import java.io.*;
import java.util.*;
/**
 * @author gus
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
class ExplorerTreeModel implements TreeModel {

    
    
    
    public static final int NB_LIMIT = 1000;
	private File root = null;
	
	
	
	public ExplorerTreeModel(){}
	
	public ExplorerTreeModel(File root)
	{this.root = root;}
	

	public void setRoot(File root)
	{this.root = root;}
	
	public Object getRoot()
	{return root;}

	
	public Object getChild(Object node, int index)
	{
		File f = (File)node;
		File[] children = f.listFiles();
		return children[index];
	}

	
	public int getChildCount(Object node)
	{
	    File f = (File)node;
		if(f==null)return 0;
		
		File[] children = f.listFiles();
		if(children==null)return 0;
		
		int n = children.length;
		if(n>NB_LIMIT)return 0;
		
		return n;
	}

	
	public boolean isLeaf(Object node)
	{
		File f = (File)node;
		return f.isFile();
	}

	
	public int getIndexOfChild(Object node, Object child)
	{
	    if(child instanceof String)
	        return 0;
	    
		File f = (File)node;
		File[] children = f.listFiles();
		return Arrays.binarySearch(children,child);
	}

	
	public void valueForPathChanged(TreePath path, Object newValue){}
	
	
	
	
	
	
	/*
	 * Code for handling TreeModelListener
	 * For later use
	 */
	
	
	private EventListenerList listenerList = new EventListenerList();
	
	public synchronized void addTreeModelListener(TreeModelListener listener)
	{listenerList.add(TreeModelListener.class,listener);}
	
	public synchronized void removeTreeModelListener(TreeModelListener listener)
	{listenerList.remove(TreeModelListener.class, listener);}

	protected void fireTreeStructureChanged(Object source, TreePath path)
	{
	    Object[] listeners = listenerList.getListenerList();
	    TreeModelEvent e = null;
	    
	    for(int i=listeners.length-2; i>=0; i-=2)
	    if(listeners[i]==TreeModelListener.class)
	    {
	        if(e==null) e = new TreeModelEvent(source, path);
	        ((TreeModelListener)listeners[i+1]).treeStructureChanged(e);
	    }          
	}
	
	
	
}
