/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.graphic.dnd;

/**
 *
 * @author  gus
 */
import java.awt.datatransfer.*;


public class ObjectTransferable implements Transferable {
    
    
    private Object object; 
    private DataFlavor[] dataFlavor;

    
    
    public ObjectTransferable(Object object, DataFlavor flavor)
    {
        this.object = object;
        dataFlavor = new DataFlavor[]{flavor};
    }
    
    
    
    
    
    public Object getTransferData(DataFlavor dataFlavor) throws UnsupportedFlavorException
    {
        if(isObjectFlavor(dataFlavor))return object;
        throw new UnsupportedFlavorException(dataFlavor);
    }
    
    
    public DataFlavor[] getTransferDataFlavors()
    {return dataFlavor;}
    
    
    
    public boolean isDataFlavorSupported(DataFlavor flavor)
    {return isObjectFlavor(flavor);}
    
    
    private boolean isObjectFlavor(DataFlavor flavor)
    {return flavor.getClass().getSimpleName().equals("ObjectFlavor");}
}
