package gus05.entity.gus.graphic.filechooser.holder;


import java.awt.Frame;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;



public class FileChooserHolder implements Entity, Provide {


    public String getName()				{return "gus.graphic.filechooser.holder";}
    public String getCreationDate()		{return "2008.09.23";}


    private Service fileView;
    private Service persist;
    private JFileChooser fc;
    
    
    public FileChooserHolder() throws Exception
    {
    	fileView = Outside.service(this,"gus.graphic.filechooser.fileview");
    	persist = Outside.service(this,"gus.graphic.persistence.persistence1");
    }


    


    public Object provide() throws Exception
    {
    	if(fc==null)
    	{
    		init();
    		fileView.give(fc);
    		persist.register(getName()+"_fc",fc);
    	}
    	return fc;
    }
	
	
	
    
    
    private void init()
    {
    	InitFileChooser init = new InitFileChooser();
    	new Thread(init).start();
    	init.setVisible(true);
    }
    
    
    
	
	private class InitFileChooser extends JDialog implements Runnable
    {
    	public InitFileChooser()
    	{
    		super((Frame)null,true);
    		setUndecorated(true);
    		setAlwaysOnTop(true);
    		JLabel label = new JLabel("  Initializing JFileChooser. Please wait a few seconds ...  ");
    		label.setFont(label.getFont().deriveFont((float)20));
    		setContentPane(label);
    		pack();
    		setLocationRelativeTo(null);
    	}
    	public void run()
    	{
    		fc = new JFileChooser();
    		setVisible(false);
    	}
    }
}

