package gus05.entity.gus.security.asymkeys.generator.demo;

import gus05.framework.core.Outside;
import gus05.framework.core.Service;



import gus05.framework.core.Entity;
import gus05.framework.features.Graphic;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.io.File;



public class GeneratorDemo implements Entity, Graphic {


    public String getName()				{return "gus.security.asymkeys.generator.demo";}
    public String getCreationDate()		{return "2008.06.12";}


    private Service generator;
    private Service checker;
    private Service explorer;
    private Service importFromClipboard;

    private JButton button_generate;
    private JButton button_check;
    private JButton button_import;
    private JPanel panel;
    
    private File storeDir;




    public GeneratorDemo() throws Exception
    {
        generator = Outside.service(this,"gus.security.asymkeys.generator");
        checker = Outside.service(this,"gus.security.asymkeys.checkkeyfiles");
        explorer = Outside.service(this,"gus.file.explorer.editingexplorer0");
        importFromClipboard = Outside.service(this,"gus.security.asymkeys.importpublickey.clipboard");
        
        storeDir = (File) Outside.resource(this,"defaultdir");
        generator.register("storeDir",storeDir);
        explorer.give(storeDir);
        
        button_generate = new JButton("generate key pair");
        button_generate.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{generate();}
		});
        
        button_check = new JButton("check key pair");
        button_check.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{check();}
		});
        
        button_import = new JButton("import from clipboard");
        button_import.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{importKey();}
		});
        
        JPanel p_top = new JPanel(new GridLayout(1,2));
        p_top.add(button_generate);
        p_top.add(button_check);
        p_top.add(button_import);
        
        panel = new JPanel(new BorderLayout());
        panel.add(p_top,BorderLayout.NORTH);
        panel.add(explorer.gui(),BorderLayout.CENTER);
    }



    public JComponent gui()
    {return panel;}

    
    
    
    private void generate()
    {
    	try
    	{
    		String id = JOptionPane.showInputDialog("Please type new ID:");
    		if(id==null) return;
    		
    		generator.give(id);
    	}
    	catch(Exception e)
    	{Outside.err(this,"generate()",e);}
    }
    
    
    
    
    private void check()
    {
    	try
    	{
    		String id = JOptionPane.showInputDialog("Please type ID to be checked:");
    		if(id==null) return;
    		
    		File file_pr = new File(storeDir,id+"."+SECURITY.PRIVATEKEY_FILEEXTENSION);
    		File file_pu = new File(storeDir,id+"."+SECURITY.PUBLICKEY_FILEEXTENSION);
    		
    		checker.give(new File[]{file_pr,file_pu});
    		JOptionPane.showMessageDialog(null,"check sucessfully completed");
    	}
    	catch(Exception e)
    	{
    		Outside.err(this,"check()",e);
    		JOptionPane.showMessageDialog(null,"check failed: "+e.toString());
    	}
    }
    
    
    
    
    
    private void importKey()
    {
    	try
    	{
    		String owner = (String) importFromClipboard.transform(storeDir);
    		JOptionPane.showMessageDialog(null,"public key sucessfully imported for owner: "+owner);
    	}
    	catch(Exception e)
    	{
    		Outside.err(this,"check()",e);
    		JOptionPane.showMessageDialog(null,"key importation failed: "+e.toString());
    	}
    }

}

