package gus05.entity.gus.security.asymkeys.rebuildpublickeyfile;



import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class RebuildPublicKeyFile implements Entity, Give {

    
    public String getName() {return "gus.security.asymkeys.rebuildpublickeyfile";}
    public String getCreationDate() {return "2008.06.12";}
    
    
    
    private Service checkKeyFiles;
    
    
    
    
    
    public RebuildPublicKeyFile() throws Exception
    {
    	checkKeyFiles = Outside.service(this,"gus.security.asymkeys.checkkeyfiles");
    }

    
    
    
    
    
    public void give(Object obj) throws Exception
	{
    	File file_privateKey = (File) obj;
    	
    	Properties pr = prop(file_privateKey);
    	Properties pu = new Properties();
    	
    	transfert(pr,pu,SECURITY.PRIVATEKEY_OWNER);
    	transfert(pr,pu,SECURITY.PRIVATEKEY_SIGN);
    	transfert(pr,pu,SECURITY.PRIVATEKEY_Y0);
    	transfert(pr,pu,SECURITY.PRIVATEKEY_P0);
    	transfert(pr,pu,SECURITY.PRIVATEKEY_Q0);
    	transfert(pr,pu,SECURITY.PRIVATEKEY_G0);
    	
    	
    	String owner = pr.getProperty(SECURITY.PRIVATEKEY_OWNER);
    	File parentDir = file_privateKey.getParentFile();
    	File file_publicKey = new File(parentDir,owner+"."+SECURITY.PUBLICKEY_FILEEXTENSION);    	
    	
    	store(file_publicKey, pu, "public key specifications for "+owner);
    	file_publicKey.setReadOnly();
    	
    	checkKeyFiles.give(new File[]{file_privateKey,file_publicKey});
	}

    
    
    
    
    private void transfert(Properties p1, Properties p2, String key) throws Exception
    {
    	if(!p1.containsKey(key)) throw new Exception("property "+key+" not found");
    	String value = p1.getProperty(key);
    	p2.setProperty(key,value);
    }
    
    
    
    
	
    private void store(File file, Properties prop, String comment) throws IOException
    {
    	FileOutputStream fos = new FileOutputStream(file);
    	prop.store(fos,comment);
    	fos.close();
    }
    
    
    
    private Properties prop(File file) throws IOException
    {
        Properties prop = new Properties();
        FileInputStream fis = new FileInputStream(file);
        prop.load(fis);
        fis.close();
        return prop;
    }
} 
