package gus05.entity.gus.security.asymkeys.tool.verifyfilesign;


import java.io.File;
import java.security.PublicKey;

import javax.swing.JOptionPane;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Give;
import gus05.framework.resources.FileProvider;



public class VerifyFileSign implements Entity, Give {


    public String getName()				{return "gus.security.asymkeys.tool.verifyfilesign";}
    public String getCreationDate()		{return "2008.09.23";}



    private FileProvider fileProvider;
    private Service verifier;
    

    public VerifyFileSign() throws Exception
    {
    	fileProvider = (FileProvider) Outside.resource(this,"gus.file.action.choose.file");
    	verifier = Outside.service(this,"gus.security.asymkeys.publickey.signverifier");
    }



    public void give(Object obj) throws Exception
    {
    	PublicKey publicKey = (PublicKey) obj;
    	File f = (File) fileProvider.getFile("open");
    	if(f==null) return;
    	String sign = JOptionPane.showInputDialog("Enter file signature");
    	if(sign==null) return;
    	
    	Filter t = (Filter) verifier.transform(publicKey);
    	boolean result = t.filter(new Object[]{f,sign});
    	
    	String message = result?"signature is valid":"signature is NOT valid";
    	JOptionPane.showMessageDialog(null,message);
    }


}

