
package gus05.entity.gus.security.messagedigest.builder2;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;
import java.security.MessageDigest;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Transform;


public class MessageDigestBuilder2 implements Entity, Transform {

    public String getName()				{return "gus.security.messagedigest.builder2";}
    public String getCreationDate()		{return "2008.06.15";}


    private Service mdInstance;
    private Service base64Encoder;
    
    private MessageDigest md;
    
    
    
    public MessageDigestBuilder2() throws Exception
    {
    	mdInstance = Outside.service(this,"gus.security.messagedigest.instance.md5");
    	base64Encoder = Outside.service(this,"gus.tostring.bytetobase64");
    	
    	md = (MessageDigest) mdInstance.provide();
    }
    
    
    
    
    
    public Object transform(Object obj) throws Exception
    {
        if(obj instanceof byte[])
            return digest(((byte[])obj));
        if(obj instanceof String)
            return digest(((String)obj).getBytes());
        if(obj instanceof InputStream)
            return digest((InputStream)obj);
        if(obj instanceof File)
            return digest(new FileInputStream((File)obj));
        if(obj instanceof URL)
            return digest(((URL)obj).openStream());
        
        throw new Exception("Invalid input: "+obj.getClass().getName());
    }
    
    
    
    
    
    private String digest(InputStream in) throws Exception
    {
    	md.reset();
        byte[] buffer = new byte[8192];
        int length;
        while((length=in.read(buffer))!=-1)
        	md.update(buffer, 0, length);
        in.close();
        
        byte[] raw = md.digest();        
        return encode(raw);
    }
    
    
    
    
    private String digest(byte[] in) throws Exception
    {
        md.reset();
        md.update(in);
        byte[] raw = md.digest();
        return encode(raw);
    }

    
    
    private String encode(byte[] data) throws Exception
    {return (String) base64Encoder.transform(data);} 
}
