
package gus05.manager.gus.endorf.layer3.tools;

import gus05.manager.gus.endorf.layer3.system1.System1;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Set;



public class Tools_file {

    

    
    public static String readText(File file) throws Exception
    {
        FileReader fr = new FileReader(file);	
        char[] a= new char[(int)file.length()];
        fr.read(a,0,(int)file.length());
        fr.close();
        return Tools_encoding.decode(new String(a)); 
    }
    
    
    
    /*
     * revoir la mthode readLines pour avoir un chargement consistent
     */
    public static String[] readLines(File file) throws Exception
    {
        String text = readText(file);
        if(text.equals("")) return new String[0];
        //text = text.replace("\r","");
        return text.split("[\r\n]+");
    }
    
    
    
    
    
    
    
    
    
    
    
    
    public static List loadList(File file) throws Exception
    {
        if(file.length()==0)return new ArrayList();
        return new ArrayList(Arrays.asList(readLines(file)));}
    
    
    public static Set loadSet(File file) throws Exception
    {
        if(file.length()==0)return new HashSet();
        return new HashSet(Arrays.asList(readLines(file)));
    }
    
    
    
    
    
    
    
    
    
    public static void writeText(File file, String text) throws Exception
    {
        if(!file.canWrite())return;
        PrintStream out = new PrintStream(file);
        out.println(Tools_encoding.encode(text));
        out.close();
    }
    
    public static void writeCollection(File file, Collection c) throws Exception
    {
        if(!file.canWrite())return;
        PrintStream out = new PrintStream(file);
        Iterator it = c.iterator();
        while(it.hasNext())
        {
            String line = (String) it.next();
            out.println(Tools_encoding.encode(line));
        }
        out.close();
    }
    
    
    
    
    
    
    
    public static Properties prop(File file) throws Exception
    {
        Properties prop = new Properties();
        FileInputStream fis = new FileInputStream(file);
        prop.load(fis);
        fis.close();
        return prop;
    }
    
    public static void saveProp(File file, Properties prop) throws Exception
    {
        FileOutputStream fos = new FileOutputStream(file);
        prop.store(fos,"");
        fos.close();
    }
    
    
    
    
    
    
    
    
    public static void initFile(File file) throws IOException
    {
        if(!file.exists())
        {
            file.getParentFile().mkdirs();
            file.createNewFile();
        }
        else backupFile(file);
    }
    
    
    
    public static void backupFile(File file) throws IOException
    {
        String backupName = file.getName()+".bak";
        File backup = new File(file.getParentFile(),backupName);
        if(backup.canWrite())
        {
            System1.printDebug(Tools_file.class,"backupFile(File)","create backup: "+backup.getAbsolutePath());
            COPY(file,backup);
        }
    }
     
    
    
    
    public static String getFileName(File file)
    {
        String fullName = file.getName();
        if(!fullName.contains(".")) return fullName;
        
        String[] n = fullName.split("\\.");
        int l = n[n.length-1].length();
        return fullName.substring(0,fullName.length()-1-l);
    }
    
    
    
    
    
    public static void COPY(File in, File out) throws IOException
    {
        out.getParentFile().mkdirs();
        
        FileInputStream fis = new FileInputStream(in);
        FileOutputStream fos = new FileOutputStream(out);
        
        FileChannel inputChannel = fis.getChannel();
        FileChannel outputChannel = fos.getChannel();
        
        outputChannel.transferFrom(inputChannel,0,in.length());
        
        fis.close();
        fos.close();
    }
    
    
    
    
    

}
