/*
 * Created on 9 aot 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gus05.manager.gus.endorf.layer4.internals1;

import gus05.framework.features.Filter;
import gus05.framework.features.Retrieve;
import gus05.manager.gus.endorf.layer2.datasupport.SupportSet;
import gus05.manager.gus.endorf.layer3.tools.Tools_file;
import gus05.manager.gus.endorf.layer4.system2.System2;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.HashSet;
import java.util.Set;


public class AppEntitySecuredList implements Filter, Retrieve, ActionListener {

    
    private File securedSetFile;
    private SupportSet securedSet;
    private boolean changed = false;
    
    private Set all;
    private Set used;
    private Set blocked;
    
    
    
    public AppEntitySecuredList()
    {init();}
    

    
    public void init()
    {
        try
        {
            all = new HashSet();
            used = new HashSet();
            blocked = new HashSet();
            
            if(!System2.hasFile(System2.PATH_SECURITYDIR)) return;
            File securityDir = System2.getFile(System2.PATH_SECURITYDIR);
            if(!securityDir.exists()) return;
            
            File securedSetFile = new File(securityDir,System2.FILENAME_SECUREDENTITYLIST);
            if(!securedSetFile.exists()) return;
            
            Set set = Tools_file.loadSet(securedSetFile);
            if(set.isEmpty()) return;
            
            securedSet = new SupportSet("securedSet", set);
            securedSet.addActionListener(this);
            
            System2.printMessage(this,"init()","secured entities="+securedSet.size());
            
            System2.finalTasks.addActionListener(new ActionListener(){
                public void actionPerformed(ActionEvent e){save();}});
        }
        catch(Exception e)
        {System2.handleError(this,"init()",e);}
    }

    
    
    public void actionPerformed(ActionEvent e)
    {changed = true;}
    
    
    
    public boolean filter(Object obj) throws Exception
    {
        String name = (String)obj;
        
        boolean result = true;
        if(securedSet!=null)
            result = securedSet.contains(name);
        
        if(result)used.add(name);
        else blocked.add(name);
        all.add(name);
        
        return result;
    }

    
    
    
    
    
    private void save()
    {
        try
        {
            if(changed && securedSet!=null)
            Tools_file.writeCollection(securedSetFile,securedSet);
        }
        catch(Exception e)
        {System2.handleError(this,"save()",e);}
    }

    

    public Object retrieve(String key) throws Exception
    {
        if(key.equals("used")) return used;
        if(key.equals("blocked")) return blocked;
        if(key.equals("secured")) return securedSet;
        if(key.equals("all")) return all;
        
        if(key.equals("keys"))
            return new String[]{"used","blocked","secured","all"};
        
        throw new Exception("Unknown key: "+key);
    }

}
