package gus05.manager.gus.endorf.layer4.system2;


import gus05.framework.features.Give;
import gus05.framework.features.Graphic;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.JScrollPane;
import javax.swing.Scrollable;
import javax.swing.UIManager;


public class GuiManager {

    
    
    public JFrame mainFrame;
    public JMenuBar menuBar;
    
    
    
    
    
    public void init()
    {
        if(!(System2.appObject instanceof JFrame))
        {
            System2.printDebug(this,"init()","this is not a graphical application");
            return;
        }
        
        mainFrame = (JFrame) System2.appObject;
        mainFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        mainFrame.addWindowListener(new WindowAdapter() {
           public void windowClosing(WindowEvent evt){System2.exitApp();}
        });
        
        String laf = System2.lookAndFeel();
        if(laf!=null) initLookAndFeel(laf);
        
        menuBar = new JMenuBar();
        mainFrame.setJMenuBar(menuBar);
     
        System2.putInternal(System2.INTERNAL_JFRAME_APPFRAME,mainFrame);
        System2.putInternal(System2.INTERNAL_JMENUBAR_APPMENUBAR,menuBar);
        
        System2.finalTasks.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {mainFrame.dispose();}
        });
    }
    
    
    
    
    
    
    private void initLookAndFeel(String laf)
    {
        try
        {
            UIManager.setLookAndFeel(laf);
            System2.printMessage(GuiManager.class,"initLookAndFeel(String)","init "+laf);
        }
        catch(Exception e)
        {System2.handleError(this,"initLookAndFeel(String)",e);}
    }
    
    
    
    
    
    
    public void startGraphic(Graphic g)
    {
        if(mainFrame==null) return;
        JComponent comp = g.gui();
        if(comp instanceof Scrollable)
        comp = new JScrollPane(comp);
        
        mainFrame.getContentPane().add(comp);
        customizeFrame();
    }
    
    
    
    
    private void customizeFrame()
    {
        try
        {
            Give customizer = (Give) System2.getInternal(System2.INTERNAL_OBJ_CUSTOMIZEFRAME);
            if(customizer==null) return;
            customizer.give(mainFrame);
        }
        catch(Exception e)
        {System2.handleError(this,"customizeFrame()",e);}
    }
    
    
    
    
    
    

    
    
    public void afterLanguageChange()
    {
        if(!mainFrame.isResizable())
        mainFrame.pack();
    }
}
